const FriendlyErrorsWebpackPlugin = require('friendly-errors-webpack-plugin');
const ReactRefreshTypeScript = require('react-refresh-typescript');


module.exports = ({ env }) => {
  const isDevelopment = env !== 'production';
  return {
    resolve: {
      extensions: ['.ts', '.js', '.tsx', 'jsx'],
    },
    module: {
      rules: [
        {
          test: /\.tsx?$/,
          use: [
            {
              loader: 'ts-loader',
              options: {
                getCustomTransformers: () => ({
                  before: isDevelopment ? [ReactRefreshTypeScript()] : [],
                }),
                // disable type checker - we will use it in fork plugin
                transpileOnly: true,
              },
            }
          ],
          exclude: /node_modules/
        },
        {
          test: /\.css$/,
          use: [
            'style-loader',
            'css-loader',
          ]
        },
        {
          test: /\.less$/,
          use: [
            'style-loader',
            'css-loader',
            'less-loader'
          ]
        },
        {
          test: /\.(woff|woff2|eot|ttf|otf|svg)$/,
          use: [
            'file-loader'
          ]
        }
      ]
    },
    plugins: [
      new FriendlyErrorsWebpackPlugin()
    ]
  }
}