const merge = require('webpack-merge');

const baseConfig = require('./webpack.config.base');
const devConfig = require('./webpack.config.dev');
const prodConfig = require('./webpack.config.prod');

const fs = require('fs');
const path = require('path');

module.exports = (env, argv) => {
  const config = argv.mode === 'development' ? devConfig : prodConfig

  let packageName = argv.packageName;
  let historyApiFallback = argv.historyApiFallback ? true : false;
  let fix = argv.fix ? argv.fix : ''

  // let file = `
  //   module.exports = {
  //     packageName: '${packageName}',
  //     historyApiFallback: ${historyApiFallback},
  //     fix: '${fix}'
  //   }
  // `

  // fs.writeFileSync(path.join(__dirname, './index.js'), file);

  return merge(config({ ...argv, fix, packageName, historyApiFallback }), baseConfig({ env: argv.mode }));
}