// const config = require('./index');
const path = require('path');
const TerserPlugin = require('terser-webpack-plugin');
const nodeExternals = require('webpack-node-externals');

const projectRoot = process.cwd();

module.exports = (config) => {
  const isNodeExternals = config.isNodeExternals === false ? false : true;
  const conf = {
    entry: {
      [config.packageName]: `./src/plugin/index.ts${config.fix}`,
      [`${config.packageName}.min`]: `./src/plugin/index.ts${config.fix}`,
    },
    output: {
      path: path.join(projectRoot, './dist'),
      filename: '[name].js',
      library: 'CustomExport',
      // libraryExport: 'default',
      libraryTarget: 'umd',
      globalObject: 'this'
    },
    mode: 'none',
    optimization: {
      minimize: true,
      minimizer: [
        new TerserPlugin({
          include: /\.min\.js$/
        })
      ]
    },
    externals: [
      nodeExternals()
    ],
    stats: 'errors-only'
  }

  if (!isNodeExternals) {
    conf.externals = [];
  }

  return conf;
}